﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Threading;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Delegate
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 다음 소수 대리자 - NextPrimeDelegate()

        /// <summary>
        /// 다음 소수 대리자
        /// </summary>
        public delegate void NextPrimeDelegate();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 계산 계속 여부
        /// </summary>
        private bool continueCalculating;

        /// <summary>
        /// 소수가 아닌 경우
        /// </summary>
        private bool notPrime;

        /// <summary>
        /// 숫자
        /// </summary>
        private long number = 3;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.startButton.Click += startButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Start 버튼 클릭시 처리하기 - startButton_Click(sender, e)

        /// <summary>
        /// Start 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void startButton_Click(object sender, EventArgs e)
        {
            if(this.continueCalculating)
            {
                this.continueCalculating = false;

                this.startButton.Content = "Resume";
            }
            else
            {
                this.continueCalculating = true;

                this.startButton.Content = "Stop";

                this.startButton.Dispatcher.BeginInvoke(DispatcherPriority.Normal, new NextPrimeDelegate(CheckNextNumber));
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 다음 숫자 체크하기 - CheckNextNumber()

        /// <summary>
        /// 다음 숫자 체크하기
        /// </summary>
        public void CheckNextNumber()
        {
            this.notPrime = false;

            for(long i = 3; i <= Math.Sqrt(this.number); i++)
            {
                if(this.number % i == 0)
                {
                    this.notPrime = true;

                    break;
                }
            }

            if(!this.notPrime)
            {
                this.bigPrimeTextBlock.Text = this.number.ToString();
            }

            this.number += 2;

            if(this.continueCalculating)
            {
                this.startButton.Dispatcher.BeginInvoke(DispatcherPriority.SystemIdle, new NextPrimeDelegate(CheckNextNumber));
            }
        }

        #endregion
    }
}